# Contribute to Sejima

First off, thanks for taking the time to contribute! 🎉👍

The following is a set of guidelines for contributing to Sejima and its packages.

Before contributing, ensure that your effort is aligned with the project's roadmap by talking to the maintainers, especially if you are going to spend a lot of time on it. Feel free to [join us on Slack](http://moveupwards.slack.com) if you are interested in helping us or [drop us an email](mailto:hi@moveupwards.dev) if you are interested in working with us.

## Code of Conduct

This project and everyone participating in it is governed by the [Sejima Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to [mailto:hi@moveupwards.dev](mailto:hi@moveupwards.dev).

## Open Development & Community Driven
Sejima is open-source under the [MIT license](https://github.com/moveupwards/sejima/blob/master/LICENSE.md). All the work done is available on GitHub.
The core team and the contributors send pull requests which go through the same validation process.

Every user can send a feature request using the [issues](https://github.com/moveupwards/sejima/issues/new?template=FEATURE_REQUEST.md) on GitHub. Feel free to upvote 👍 [existing feature request](https://github.com/moveupwards/sejima/projects)

## Repository Organization
We will do our best to keep the master branch as clean as possible, with tests passing all the times. However, it can happen that the master branch moves faster than the release cycle. To ensure you have the latest stable version, please refer to the [release on cocoapods](https://cocoapods.org/pods/sejima).

If you send a pull request, please do it against the `develop` branch. We are developing upcoming versions separately to ensure non-breaking changes from master to the latest stable major version.

***

## Setup Development Environment
To facilitate the contribution, we drastically reduce the amount of commands necessary to install the entire library. First of all, you need to check if you're using the [required versions of xcode and swift version](https://github.com/MoveUpwards/Sejima#requirements)

Then, please follow the instructions below:

#### 1. Fork the repository

[Go to the repository](https://github.com/MoveUpwards/Sejima) and fork it to your own GitHub account.

#### 2. Clone from your repository

```bash
git clone git@github.com:YOUR_USERNAME/sejima.git
```

## Reporting an issue

Before reporting an issue you need to make sure:
- You are experiencing a concrete technical issue with Sejima (ideas and feature proposals should happen [on Slack](http://moveupwards.slack.com)).
- You are not asking a question about how to use Sejima or about whether or not Sejima has a certain feature. For general help using Sejima, please refer to [the official Sejima documentation](https://moveupwards.github.io/Sejima/). For additional help, ask a question on [StackOverflow](http://stackoverflow.com/questions/tagged/sejima).
- You have already searched for related [issues](https://github.com/moveupwards/sejima/issues), and found none open (if you found a related _closed_ issue, please link to it in your post).
- Your issue title is concise, on-topic and polite.
- You can provide steps to reproduce this issue that others can follow.
- You have tried all the following (if relevant) and your issue remains.